unit closeposition;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  TfrmClosePosition = class(TForm)
    GroupBox2: TGroupBox;
    Bevel1: TBevel;
    lblBidAsk: TLabel;
    btnClose: TButton;
    btnRequest: TButton;
    Timer1: TTimer;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnRequestClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmClosePosition: TfrmClosePosition;
  bid,ask:double;
  donShowLiveQuotes2:boolean;

  exemode:integer;
  isBuyPosition:boolean;
  symbol:string;
  lots:double;
  order:integer;

implementation

{$R *.DFM}
uses MetaTraderAPI, main;

var   Hsocket:integer;
      t:integer;

procedure TfrmClosePosition.FormShow(Sender: TObject);
var error:integer;
begin
  HSocket:=main.frmMain.connect(main.server,main.port);
  error:=MTApi.Login(HSocket,main.login,main.password);
  if error<>RET_OK
  then ShowMessage(' .  : '+MTApi.GetErrorDescription(error));
  if exemode=EXE_REQUEST
  then
    begin
      btnClose.Enabled:=false;
      btnRequest.Enabled:=true;
    end
  else
    begin
      btnClose.Enabled:=true;
      btnRequest.Enabled:=false;
    end;
end;

procedure TfrmClosePosition.FormCreate(Sender: TObject);
begin
   HSocket:=-1;
end;

procedure TfrmClosePosition.btnRequestClick(Sender: TObject);
var
  error:integer;
begin
    error:=MTAPI.GetPrices(HSocket,pchar(symbol),round(100*lots),@bid,@ask);
    if error<>RET_OK then lblBidAsk.Caption:=MTApi.GetErrorDescription(error)
    else lblBidAsk.Caption:=FloatToStrF(bid,fffixed,10,4)+'/'+FloatToStrF(ask,fffixed,10,4);
    btnRequest.Enabled:=false;
    btnClose.Enabled:=true;
    t:=5;
    Timer1.Enabled:=true;
end;

procedure TfrmClosePosition.Timer1Timer(Sender: TObject);
begin
  if t>0 then GroupBox2.Caption:='Market Order    '+intToStr(t) else
    begin
       GroupBox2.Caption:='Market Order';
       Timer1.Enabled:=false;
       btnClose.Enabled:=false;
    end;
  t:=t-1;
end;

procedure TfrmClosePosition.btnCloseClick(Sender: TObject);
var error:integer;
begin
  if isBuyPosition then error:=MTApi.CloseOrder(HSocket,order,bid,round(100*lots))
  else error:=MTApi.CloseOrder(HSocket,order,ask,round(100*lots));
  donShowLiveQuotes2:=true;
  if error<>RET_OK then lblBidAsk.Caption:=MTApi.GetErrorDescription(error)
  else close;
end;

procedure TfrmClosePosition.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if HSocket>-1 then main.frmMain.disconnect(HSocket);
  HSocket:=-1;
  Timer1.Enabled:=false;
  CanClose:=true;
end;

end.
