//+------------------------------------------------------------------+
//|                                           MetaTrader API Example |
//|                                       Copyright 2003, Alpari Ltd |
//|                                                +7 (095) 2507-257 | 
//|                                         http://www.alpari-idc.ru |
//+------------------------------------------------------------------+

unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls, Grids, CheckLst, MetaTraderAPI;

type
  TfrmMain = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    edtLogin: TEdit;
    edtPassword: TEdit;
    btnConnect: TBitBtn;
    btnOpenDemoAccount: TBitBtn;
    btnDisconnect: TBitBtn;
    Label3: TLabel;
    edtServer: TEdit;
    Label4: TLabel;
    edtPort: TEdit;
    Shape1: TShape;
    Label5: TLabel;
    edtFIO: TEdit;
    Label6: TLabel;
    edtEmail: TEdit;
    Label7: TLabel;
    edtAddress: TEdit;
    Label8: TLabel;
    edtCountry: TEdit;
    Label9: TLabel;
    edtState: TEdit;
    Label10: TLabel;
    edtZIPcode: TEdit;
    Label11: TLabel;
    edtPhone: TEdit;
    Label12: TLabel;
    cbxType: TComboBox;
    Label13: TLabel;
    edtCity: TEdit;
    Label14: TLabel;
    edtBalance: TEdit;
    Label15: TLabel;
    cbxLeverage: TComboBox;
    GroupBox2: TGroupBox;
    sgrMarketWatch: TStringGrid;
    btnChangePassword: TBitBtn;
    Shape2: TShape;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    GroupBox5: TGroupBox;
    sgrOpenPositions: TStringGrid;
    GroupBox6: TGroupBox;
    edtDir: TEdit;
    btnChangeWorkingDir: TBitBtn;
    sgrRatesHistory: TStringGrid;
    cbxSymbol: TComboBox;
    cbxPeriod: TComboBox;
    Label16: TLabel;
    edtDate0: TEdit;
    btnGetRates: TBitBtn;
    GroupBox7: TGroupBox;
    sgrAccountHistory: TStringGrid;
    Bevel1: TBevel;
    cxbAccountHistoryPeriod: TComboBox;
    btnGetAccountHistory: TBitBtn;
    Bevel2: TBevel;
    Bevel3: TBevel;
    btnNewOrder: TBitBtn;
    btnModifyOrder: TBitBtn;
    btnDelPending: TBitBtn;
    btnCloseOrder: TBitBtn;
    btnCloseBy: TBitBtn;
    Label17: TLabel;
    cbxOrderBy: TComboBox;
    lbxNews: TListBox;
    lbxMail: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure btnConnectClick(Sender: TObject);
    procedure btnOpenDemoAccountClick(Sender: TObject);
    procedure btnDisconnectClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure WndProc(var Message: TMessage);override;
    procedure btnChangePasswordClick(Sender: TObject);
    procedure btnChangeWorkingDirClick(Sender: TObject);
    procedure btnGetRatesClick(Sender: TObject);
    procedure lbxNewsDblClick(Sender: TObject);
    procedure btnGetAccountHistoryClick(Sender: TObject);
    procedure lbxMailDblClick(Sender: TObject);
    procedure btnNewOrderClick(Sender: TObject);
    procedure btnDelPendingClick(Sender: TObject);
    procedure btnCloseByClick(Sender: TObject);
    procedure btnModifyOrderClick(Sender: TObject);
    procedure sgrOpenPositionsSelectCell(Sender: TObject; ACol,
      ARow: Integer; var CanSelect: Boolean);
    procedure btnCloseOrderClick(Sender: TObject);
  private
    { Private declarations }
    //   /
    procedure GetUpdatedTickInfo(handle:integer);
    //  
    procedure GetLastNews(handle:integer);
    //  
    procedure GetLastTrades(handle:integer);
    //  
    procedure GetLastMail(handle:integer);
  public
    { Public declarations }
    //      ,   .
    function connect(server:string; port:integer):integer;
    //      
    procedure disconnect(handle:integer);
  end;

var
  frmMain: TfrmMain;
  Symbols_exemode:array of integer;
  MTApi: TMTApi;
  HPumpingSocket: integer;
  server, password: string;
  port, login: integer;

implementation

{$R *.DFM}
uses  ShowMailBody, NewOrder, ModifyOrder, ClosePosition;

var WM_MetaTraderAPIPumpingMessage: cardinal;
    MailPaths:                      TStringList;

//      ,   .
function TfrmMain.connect(server:string; port:integer):integer;
var HSocket,error:integer;
begin
  HSocket:=MTApi.CreateSocket;
  if HSocket=-1 then ShowMessage('   ')
  else
    begin
      //   
      error:=MTApi.Connect(HSocket,server,port);
      if error<>RET_OK then ShowMessage('    .  : '+MTApi.GetErrorDescription(error));
    end;
  Result:=HSocket;
end;

//      
procedure TfrmMain.disconnect(handle:integer);
var error:integer;
begin
  //
  error := MTApi.Disconnect(handle);
  if (error <> RET_OK)and(error <> RET_OK_NONE) then ShowMessage('    .  : '+MTApi.GetErrorDescription(error));

  // 
  error := MTApi.DeleteSocket(handle);
  if error <> RET_OK then ShowMessage('   .  : '+MTApi.GetErrorDescription(error));
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  //    
  WM_MetaTraderAPIPumpingMessage := RegisterWindowMessage('MetaTraderAPI_Pumping_Message');

  MailPaths := TStringList.Create;

  MtAPI := TMTApi.Create;
  HPumpingSocket := -1;

  cbxType.ItemIndex := 0;
  cbxPeriod.ItemIndex := 0;
  cbxLeverage.ItemIndex := 0;
  edtDate0.text := DateToStr(Now)+' 00:00:00';
  cxbAccountHistoryPeriod.ItemIndex := 0;

  sgrMarketWatch.Cells[0,0] := '  Symbol';
  sgrMarketWatch.Cells[1,0] := '    Bid';
  sgrMarketWatch.Cells[2,0] := '    Ask';

  sgrOpenPositions.Cells[0,0] := 'Ticket';
  sgrOpenPositions.Cells[1,0] := 'Time';
  sgrOpenPositions.Cells[2,0] := 'Type';
  sgrOpenPositions.Cells[3,0] := 'Lots';
  sgrOpenPositions.Cells[4,0] := 'Symbol';
  sgrOpenPositions.Cells[5,0] := 'Open Price';
  sgrOpenPositions.Cells[6,0] := 'S/L';
  sgrOpenPositions.Cells[7,0] := 'T/P';
  sgrOpenPositions.Cells[8,0] := 'Curr. Price';
  sgrOpenPositions.Cells[9,0] := 'Comm';
  sgrOpenPositions.Cells[10,0]:= 'Swap';
  sgrOpenPositions.Cells[11,0]:= 'Profit';
  sgrOpenPositions.Cells[12,0]:= 'Comments';

  sgrRatesHistory.Cells[0,0] := 'Time';
  sgrRatesHistory.Cells[1,0] := 'Open';
  sgrRatesHistory.Cells[2,0] := 'Low';
  sgrRatesHistory.Cells[3,0] := 'High';
  sgrRatesHistory.Cells[4,0] := 'Close';
  sgrRatesHistory.Cells[5,0] := 'Volume';

  sgrAccountHistory.cells[0,0] := 'Ticket';
  sgrAccountHistory.cells[1,0] := 'Time';
  sgrAccountHistory.cells[2,0] := 'Type';
  sgrAccountHistory.cells[3,0] := 'Lots';
  sgrAccountHistory.cells[4,0] := 'Symbol';
  sgrAccountHistory.cells[5,0] := 'Price';
  sgrAccountHistory.cells[6,0] := 'S/L';
  sgrAccountHistory.cells[7,0] := 'T/P';
  sgrAccountHistory.cells[8,0] := 'Time';
  sgrAccountHistory.cells[9,0] := 'Price';
  sgrAccountHistory.cells[10,0]:= 'Comm';
  sgrAccountHistory.cells[11,0]:= 'Swap';
  sgrAccountHistory.cells[12,0]:= 'Profit';
  sgrAccountHistory.cells[13,0]:= 'Comments';

  edtDir.text := ExtractFilePath(application.exeName);
end;

procedure TfrmMain.btnConnectClick(Sender: TObject);
var error, count, i: integer;
    pcs:   PAConSecurity;
begin
  server := edtServer.text;
  try
    port := StrToInt(edtPort.text);
  except
    begin
      showMessage('    .     1950.');
      port:=1950;
    end;
  end;
  //         
  HPumpingSocket:=Connect(server,port);
  if HPumpingSocket>-1 then
    begin
      // 
      try
        password := edtPassword.text;
        login    := StrToInt(edtLogin.text);

        error    := MTApi.Login(HPumpingSocket,login,password);
      except
        begin
          ShowMessage('    ');
          login:=0;
          error:=-1;
        end;
      end;

      if error<>RET_OK
      then ShowMessage(' .  : '+MTApi.GetErrorDescription(error))
      else
        begin
          //    
          btnOpenDemoAccount.Enabled:=false;
          btnConnect.Enabled:=false;
          btnDisConnect.Enabled:=true;
          edtLogin.Enabled:=false;
          edtPassword.Enabled:=false;
          btnChangePassword.Enabled:=true;

          //     securities.dat
          error:=MTApi.RefreshSecurities(HPumpingSocket);
          if error<>RET_OK then ShowMessage('       securities.dat.  : '+MTApi.GetErrorDescription(error));

          //      
          error:=MTApi.SetPumpingMode(HPumpingSocket, frmMain.handle, MTApi.WM_MetaTraderAPIPumpingMessage);
          if error<>RET_OK then ShowMessage('      .  : '+MTApi.GetErrorDescription(error));

          //   
          count:=0;
          try
            pcs := MTApi.GetSecurities(HPumpingSocket, @count);
            if pcs = nil
              then showMessage('     ')
              else
                begin
                  sgrMarketWatch.RowCount:=2;
                  sgrMarketWatch.RowCount:=count+1;
                  cbxSymbol.Items.Clear;
                  frmNewOrder.cbxSymbols.Items.Clear;
                  setLength(Symbols_exemode,count);
                  for i:=0 to count-1 do
                    begin
                      sgrMarketWatch.Cells[0,i+1]:=string(pcs^[i].name);
                      cbxSymbol.Items.Add(string(pcs^[i].name));
                      frmNewOrder.cbxSymbols.Items.Add(string(pcs^[i].name));
                      Symbols_exemode[i]:=pcs^[i].exemode;

                      //       
                      error:=MTApi.AddSymbol(HPumpingSocket,string(pcs^[i].name));
                      if error<>RET_OK then ShowMessage('         .  : '+MTApi.GetErrorDescription(error));

                      //         :
                      {
                      error:=MTApi.HideSymbol(, );
                      if error<>RET_OK then ShowMessage('         .  : '+MTApi.GetErrorDescription(error));
                      }
                    end;
                  cbxSymbol.ItemIndex:=0;
                  frmNewOrder.cbxSymbols.ItemIndex:=0;
                end;
          finally
            HeapFree(GetProcessHeap, 0, pcs);
          end;

          //  
          GetUpdatedTickInfo(HPumpingSocket);
        end;
    end;
end;

//  
procedure TfrmMain.GetUpdatedTickInfo(handle:integer);
var count,i,j: integer;
    pti:   PATickInfo;
begin
  count:=0;
  pti:=MTApi.GetUpdatedTickInfo(handle,@count);
  try
    if pti=nil
    then showMessage('    ')
    else
      begin
        for i:=0 to count-1 do
          begin
            Application.ProcessMessages;
            for j:=1 to count do
              begin
                Application.ProcessMessages;
                if (string(pti^[i].symbol))=sgrMarketWatch.Cells[0,j]
                then
                  begin
                    sgrMarketWatch.Cells[1,j]:=FloatToStrF(pti^[i].bid,fffixed,8,4);
                    sgrMarketWatch.Cells[2,j]:=FloatToStrF(pti^[i].ask,fffixed,8,4);
                    if (Symbols_exemode[frmNewOrder.cbxSymbols.ItemIndex]=EXE_MARKET)and(not(donShowLiveQuotes)) then
                      begin
                        if frmNewOrder.cbxSymbols.Text=string(pti^[i].symbol)
                        then
                          begin
                            frmNewOrder.lblBidAsk.Caption:=FloatToStrF(pti^[i].bid,fffixed,8,4)+'/'+FloatToStrF(pti^[i].ask,fffixed,8,4);
                            neworder.bid:=pti^[i].bid;
                            neworder.ask:=pti^[i].ask;
                          end;
                      end;
                    if not(donShowLiveQuotes2) then
                      begin
                        if (ClosePosition.exemode=EXE_MARKET)and(ClosePosition.symbol=string(pti^[i].symbol))
                        then
                          begin
                            frmClosePosition.lblBidAsk.Caption:=FloatToStrF(pti^[i].bid,fffixed,8,4)+'/'+FloatToStrF(pti^[i].ask,fffixed,8,4);
                            ClosePosition.bid:=pti^[i].bid;
                            ClosePosition.ask:=pti^[i].ask;
                          end;
                      end;
                    break;
                  end;
              end;
          end;
      end;
  finally
    HeapFree(GetProcessHeap, 0, pti);
  end;
end;

// -
procedure TfrmMain.btnOpenDemoAccountClick(Sender: TObject);
var error:integer;
    HSocket: integer;
    acc: TDemoAccountInfo;
begin
  //    -    
  try
    port:=StrToInt(edtPort.text);
  except
    port:=1950;
  end;
  HSocket:=connect(edtServer.text,port);

  // -
  FillChar(acc,SizeOf(TDemoAccountInfo),#0);
  strCopy(acc.name,pchar(edtFIO.text));
  strCopy(acc.email,pchar(edtEMail.text));
  strCopy(acc.address,pchar(edtAddress.text));
  strCopy(acc.city,pchar(edtCity.text));
  strCopy(acc.country,pchar(edtCountry.text));
  strCopy(acc.state,pchar(edtState.text));
  strCopy(acc.phone,pchar(edtPhone.text));
  strCopy(acc.zipcode,pchar(edtZIPcode.text));
  case cbxType.itemIndex of
    0: strCopy(acc.group,pchar('demoforex'));
    1: strCopy(acc.group,pchar('demominiforex'));
    2: strCopy(acc.group,pchar('democfd'));
    3: strCopy(acc.group,pchar('demostocks'));
    4: strCopy(acc.group,pchar('demofutures'));
    5: strCopy(acc.group,pchar('demoall'));
  end;
  try
    acc.balance:=StrToFloat(edtBalance.text);
  except
    acc.balance:=5000;
  end;
  case cbxLeverage.ItemIndex of
    0: acc.leverage:=100;
    1: acc.leverage:=33;
    2: acc.leverage:=20;
    3: acc.leverage:=10;
  end;
  error:=MTApi.OpenDemoAccount(HSocket,@acc);
  if error<>RET_OK
  then ShowMessage('   -.  : '+MTApi.GetErrorDescription(error))
  else
    begin
      //   -  
      edtLogin.Text:=IntToStr(acc.login);
      edtPassword.text:=string(acc.password);

      //      
      disconnect(HSocket);

      //         
      btnConnectClick(self);
    end;
end;

//   
procedure TfrmMain.btnDisconnectClick(Sender: TObject);
begin
  if HPumpingSocket<>-1 then
    begin
      DisConnect(HPumpingSocket);

      btnOpenDemoAccount.Enabled:=true;
      btnConnect.Enabled:=true;
      btnDisconnect.Enabled:=false;
      edtPassword.Enabled:=true;
      edtLogin.Enabled:=true;
      btnChangePassword.Enabled:=false;

      HPumpingSocket:=-1;
    end;
end;

procedure TfrmMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  try
  finally
    btnDisconnectClick(self);
    MTApi.Destroy;
    MailPaths.Free;
    CanClose:=true;
  end;
end;

procedure TfrmMain.WndProc(var Message: TMessage);
begin
  if Message.Msg =  WM_MetaTraderAPIPumpingMessage
  then
    case Message.WParam of
     UPDATE_BIDASK: begin
                      // 
                      GetUpdatedTickInfo(Message.LParam);
                    end;
     UPDATE_NEWS:   begin
                      // 
                      GetLastNews(Message.LParam);
                    end;
     UPDATE_TRADES: begin
                      //  
                      GetLastTrades(Message.LParam);
                    end;
     UPDATE_MAIL:   begin
                      // 
                      GetLastMail(Message.LParam);
                    end;
     END_PUMPING:   begin
                      //  
                    end;
    end
  else
   inherited WndProc(Message)
end;

// 
procedure TfrmMain.btnChangePasswordClick(Sender: TObject);
var HSocket, error:integer;
    ClickedOK: boolean;
    s:string;
begin
  ClickedOK := InputQuery(' ', ' ', s);
  if ClickedOK then
    begin
      //      
      HSocket:=Connect(server,port);
      //
      error:=MTApi.Login(HSocket,login,password);
      if error <> RET_OK then ShowMessage('  .  : '+MTApi.GetErrorDescription(error));

      // 
      error:=MTApi.ChangePassword(HSocket,pchar(s));
      if error <> RET_OK
        then ShowMessage('   .  : '+MTApi.GetErrorDescription(error))
        else edtPassword.text:=s;

      //  
      Disconnect(HSocket);
    end;
end;

//  
procedure TfrmMain.btnChangeWorkingDirClick(Sender: TObject);
var error:integer;
begin
  error:=MTApi.SetWorkingDirectory(edtDir.text);
  if error <> RET_OK
    then ShowMessage('    .  : '+MTApi.GetErrorDescription(error))
    else ShowMessage('  ');
end;

//  
procedure TfrmMain.btnGetRatesClick(Sender: TObject);
var  pri:PARateInfo;
     HSocket, i, count, period, error:integer;
     s:string;
begin
  btnGetRates.Enabled:=false;

  // .    
  HSocket:=connect(server,port);
  if HSocket>-1 then
    begin
      //  
      error:=MTApi.Login(HSocket,login,password);
      if error <> RET_OK then ShowMessage('    .  : '+MTApi.GetErrorDescription(error));
      count:=0;
      case cbxPeriod.ItemIndex of
        0: period:=PERIOD_W1;
        1: period:=PERIOD_D1;
        2: period:=PERIOD_H4;
        3: period:=PERIOD_H1;
        4: period:=PERIOD_M30;
        5: period:=PERIOD_M15;
        6: period:=PERIOD_M5;
        7: period:=PERIOD_M1;
      end;
      try
        pri:=MTApi.GetRates(HSocket,cbxSymbol.Text,period,StrToDateTime(edtDate0.text),@count);
        if pri=nil then showMessage('      '+cbxSymbol.text)
        else
          begin
            sgrRatesHistory.RowCount:=2;
            sgrRatesHistory.RowCount:=count+1;
            sgrRatesHistory.cells[0,0]:='Time';
            sgrRatesHistory.cells[1,0]:='Open';
            sgrRatesHistory.cells[2,0]:='High';
            sgrRatesHistory.cells[3,0]:='Low';
            sgrRatesHistory.cells[4,0]:='Close';
            sgrRatesHistory.cells[5,0]:='Volume';
            for i:=1 to count do
              begin
                Application.ProcessMessages;
                s:=DateTimeToStr(_fromunixtime(pri^[i-1].ctm));
                if AnsiPos(':',s)=0 then s:=s+' 00:00:00';
                s:=s+'_';
                s:=copy(s,1,ansiPos(':00_',s)-1);
                sgrRatesHistory.cells[0,i]:=s;
                sgrRatesHistory.cells[1,i]:=FloatToStrF(pri^[i-1].open,fffixed,8,4);
                sgrRatesHistory.cells[2,i]:=FloatToStrF(pri^[i-1].high,fffixed,8,4);
                sgrRatesHistory.cells[3,i]:=FloatToStrF(pri^[i-1].low,fffixed,8,4);
                sgrRatesHistory.cells[4,i]:=FloatToStrF(pri^[i-1].close,fffixed,8,4);
                sgrRatesHistory.cells[5,i]:=IntToStr(pri^[i-1].vol);
              end;
          end;
      finally
        HeapFree(GetProcessHeap, 0, pri);
      end;

      //  
      disconnect(HSocket);
    end;

  btnGetRates.Enabled:=true;
end;

//  
procedure TfrmMain.GetLastNews(handle:integer);
var pnt: PANewsTopic;
    count,i:integer;
begin
  count:=0;
  try
    pnt:=MTApi.GetLastNews(handle,@count);
    if pnt=nil then showMessage('    ')
    else
      begin
        //   listbox
        for i:=0 to count-1 do
          lbxNews.items.AddObject(string(pnt^[i].ctm)+' '+string(pnt^[i].topic),TObject(pnt^[i].newkey));
      end;
  finally
    HeapFree(GetProcessHeap, 0, pnt);
  end;
end;

//  
procedure TfrmMain.lbxNewsDblClick(Sender: TObject);
var HSocket, i, key, error:integer;
    p:pchar;
begin
  for i:=0 to lbxNews.Items.Count-1 do
     if lbxNews.selected[i] then
       begin
         //  
         HSocket:=connect(server,port);
         if HSocket>-1 then
           begin
             //  
             error:=MTApi.Login(HSocket,login,password);
             if error <> RET_OK then ShowMessage('    .  : '+MTApi.GetErrorDescription(error))
             else
               begin
                 //  
                 key:=integer(lbxNews.Items.Objects[i]);
                 try
                   p:=MTApi.GetNewsBody(HSocket,key);
                   if p<>nil then ShowMessage(string(p)) else ShowMessage('NO DATA');
                 finally
                   HeapFree(GetProcessHeap, 0, p);
                 end;
               end;

             //  
             disconnect(HSocket);
           end;
       end;
end;

//  
procedure TfrmMain.btnGetAccountHistoryClick(Sender: TObject);
var HSocket, error, i, count:integer;
    ptr: PATradeRecord;
    ttime,ftime:TDateTime;
begin
  // .    
  HSocket:=connect(server,port);
  if HSocket>-1 then
    begin
      //  
      error:=MTApi.Login(HSocket,login,password);
      if error <> RET_OK then ShowMessage('    .  : '+MTApi.GetErrorDescription(error))
      else
        begin
          count:=0;
          ttime:=date;
          case cxbAccountHistoryPeriod.ItemIndex of
            0: ftime:=StrToDate('01.01.99'); //all
            1: ftime:=date-92;               //3 m
            2: ftime:=date-31;               //1 m
            3: ftime:=date-7;                //1 w
            4: ftime:=date;                  //1 d
          end;

          try
            ptr:=MTApi.GetTradeHistory(HSocket,ftime,ttime,@count);
            if ptr=nil then showMessage('    ')
            else
              begin
                sgrAccountHistory.RowCount:=2;
                sgrAccountHistory.RowCount:=count+1;

                for i:=1 to count do
                  begin
                    sgrAccountHistory.cells[0,i]:=intToStr(ptr^[i-1].order);
                    sgrAccountHistory.cells[1,i]:=DateTimeToStr(_fromunixtime(ptr^[i-1].open_time));
                    case ptr^[i-1].cmd of
                      OP_BUY:       sgrAccountHistory.cells[2,i]:='Buy';
                      OP_SELL:      sgrAccountHistory.cells[2,i]:='Sell';
                      OP_BUY_LIMIT: sgrAccountHistory.cells[2,i]:='Buy Limit';
                      OP_SELL_LIMIT:sgrAccountHistory.cells[2,i]:='Sell Limit';
                      OP_BUY_STOP:  sgrAccountHistory.cells[2,i]:='Buy Stop';
                      OP_SELL_STOP: sgrAccountHistory.cells[2,i]:='Sell Stop';
                      OP_BALANCE:   sgrAccountHistory.cells[2,i]:='Balance';
                      OP_CREDIT:    sgrAccountHistory.cells[2,i]:='Credit';
                    end;
                    sgrAccountHistory.cells[3,i]:=FloatToStrF(ptr^[i-1].volume/100,fffixed,5,1);
                    sgrAccountHistory.cells[4,i]:=string(ptr^[i-1].Symbol);
                    sgrAccountHistory.cells[5,i]:=FloatToStrF(ptr^[i-1].open_price,fffixed,8,4);
                    sgrAccountHistory.cells[6,i]:=FloatToStrF(ptr^[i-1].sl,fffixed,8,4);;
                    sgrAccountHistory.cells[7,i]:=FloatToStrF(ptr^[i-1].tp,fffixed,8,4);
                    sgrAccountHistory.cells[8,i]:=DateTimeToStr(_fromunixtime(ptr^[i-1].close_time));
                    sgrAccountHistory.cells[9,i]:=FloatToStrF(ptr^[i-1].close_price,fffixed,8,4);
                    sgrAccountHistory.cells[10,i]:=FloatToStrF(ptr^[i-1].commission,fffixed,4,1);
                    sgrAccountHistory.cells[11,i]:=FloatToStrF(ptr^[i-1].storage,fffixed,8,2);
                    sgrAccountHistory.cells[12,i]:=FloatToStrF(ptr^[i-1].profit,fffixed,10,2);
                    sgrAccountHistory.cells[13,i]:=string(ptr^[i-1].comment);
                  end;
              end;
          finally
            HeapFree(GetProcessHeap, 0, ptr);
          end;
        end;

      //  
      disconnect(HSocket);
    end;
end;

//  
procedure TfrmMain.GetLastTrades(handle:integer);
var count,i:integer;
    ptr : PATradeRecord;
    bui:   TBriefUserInfo;
begin
  //      . ,      
  //error:=MTApi.GetTrades(handle);
  //if error <> RET_OK then ShowMessage('     .  : '+MTApi.GetErrorDescription(error));

  //   .
  count:=0;
  FillChar(BUI,SizeOf(TBriefUserInfo),#0);
  try
    PTR := MTApi.GetTradeRecords(handle, @BUI, @Count);
    if PTR <> nil then
      begin
        sgrOpenPositions.RowCount:=1;
        if count>0 then sgrOpenPositions.RowCount:=count+1 else
          begin
            sgrOpenPositions.RowCount:=2;
            for i:=0 to 12 do sgrOpenPositions.cells[i,1]:='';
          end;
        sgrOpenPositions.FixedRows:=1;
        cbxOrderBy.Clear;
        for i:=1 to count do
          begin
            Application.ProcessMessages;
            sgrOpenPositions.cells[0,i]:=intToStr(ptr^[i-1].order);
            sgrOpenPositions.cells[1,i]:=DateTimeToStr(_fromunixtime(ptr^[i-1].open_time));
            case ptr^[i-1].cmd of
              OP_BUY:       sgrOpenPositions.cells[2,i]:='Buy';
              OP_SELL:      sgrOpenPositions.cells[2,i]:='Sell';
              OP_BUY_LIMIT: sgrOpenPositions.cells[2,i]:='Buy Limit';
              OP_SELL_LIMIT:sgrOpenPositions.cells[2,i]:='Sell Limit';
              OP_BUY_STOP:  sgrOpenPositions.cells[2,i]:='Buy Stop';
              OP_SELL_STOP: sgrOpenPositions.cells[2,i]:='Sell Stop';
              OP_BALANCE:   sgrOpenPositions.cells[2,i]:='Balance';
              OP_CREDIT:    sgrOpenPositions.cells[2,i]:='Credit';
            end;
            sgrOpenPositions.cells[3,i]:=FloatToStrF(ptr^[i-1].volume/100,fffixed,5,1);
            sgrOpenPositions.cells[4,i]:=string(ptr^[i-1].Symbol);
            sgrOpenPositions.cells[5,i]:=FloatToStrF(ptr^[i-1].open_price,fffixed,8,4);
            sgrOpenPositions.cells[6,i]:=FloatToStrF(ptr^[i-1].sl,fffixed,8,4);;
            sgrOpenPositions.cells[7,i]:=FloatToStrF(ptr^[i-1].tp,fffixed,8,4);
            sgrOpenPositions.cells[8,i]:=FloatToStrF(ptr^[i-1].close_price,fffixed,8,4);
            sgrOpenPositions.cells[9,i]:=FloatToStrF(ptr^[i-1].commission,fffixed,4,1);
            sgrOpenPositions.cells[10,i]:=FloatToStrF(ptr^[i-1].storage,fffixed,8,2);
            sgrOpenPositions.cells[11,i]:=FloatToStrF(ptr^[i-1].profit,fffixed,10,2);
            sgrOpenPositions.cells[12,i]:=string(ptr^[i-1].comment);
          end;
      end;
    if bui.equity=0 then GroupBox5.Caption:='  '+intToStr(bui.login)+' '+string(bui.name)+' Equity:'+FloatToStrF(bui.balance,fffixed,10,2)+' Balance:'+FloatToStrF(bui.balance,fffixed,10,2)
    else GroupBox5.Caption:='  '+intToStr(bui.login)+' '+string(bui.name)+' Equity:'+FloatToStrF(bui.equity,fffixed,10,2)+' Balance:'+FloatToStrF(bui.balance,fffixed,10,2);
    cbxOrderBy.ItemIndex:=0;
  finally
    HeapFree(GetProcessHeap, 0, PTR);
  end;
end;

//     
procedure TfrmMain.GetLastMail(handle:integer);
var sss:string;
    error:integer;
    f:File;
    mbh:TMailBoxHeader;
begin
  error:=MTApi.GetLastMail(handle,sss);
  if (sss<>'')and(error=RET_OK) then
    begin
      AssignFile(F, sss);
      Reset(F, 1);
      BlockRead(F, mbh, sizeOf(TMailBoxHeader));
      mbh.from[63] := char(0);
      mbh.subject[127] := char(0);
      lbxMail.Items.Add(DateTimeToStr(_fromunixtime(mbh.time))+' From: '+string(mbh.from)+' Subject: '+string(mbh.subject));
      MailPaths.Add(sss);
      closeFile(f);
    end
  else showMessage('    ,  .  : '+MTApi.GetErrorDescription(error));
end;

//   
procedure TfrmMain.lbxMailDblClick(Sender: TObject);
var i,j:integer;
    F:File;
    Buf: array[1..128] of Char;
    s:string;
begin
  frmMailBody.memMailBody.Clear;
  for i:=0 to lbxMail.Items.Count-1 do
     if lbxMail.selected[i] then
        begin
          s:=MailPaths.Strings[i];
          AssignFile(F, s);
          Reset(F, 1);
          Seek(f,sizeOf(TMailBoxHeader));
          s:='';
          repeat
             Fillchar(buf,sizeOf(buf),#0);
             BlockRead(F, buf, sizeOf(buf),j);
             s:=s+string(buf);
             while ansiPos(#13+#10,s)<>0 do
               begin
                 frmMailBody.memMailBody.lines.add(copy(s,1,ansiPos(#13+#10,s)-1));
                 s:=copy(s,ansiPos(#13+#10,s)+2,length(s)-ansiPos(#13+#10,s)-1);
               end;
          until j=0;
          s:=copy(s,1,ansiPos(#13,s)-1);
          frmMailBody.memMailBody.lines.add(s);
          closeFile(f);
          frmMailBody.showModal;
        end;
end;

procedure TfrmMain.btnNewOrderClick(Sender: TObject);
begin
   frmNewOrder.lblBidAsk.Caption:='Please Request';
   donShowLiveQuotes:=false;
   frmNewOrder.showModal;
end;

procedure TfrmMain.btnDelPendingClick(Sender: TObject);
var s:string;
    error:integer;
    HSocket: integer;
begin
  HSocket:=connect(server,port);
  error:=MTApi.Login(HSocket,login,password);
  if error<>RET_OK
  then ShowMessage(' .  : '+MTApi.GetErrorDescription(error));

  s:=sgrOpenPositions.cells[2,sgrOpenPositions.Selection.Top];
  if (s='Buy Limit') or (s='Buy Stop') or (s='Sell Limit') or (s='Sell Stop') then
    begin
      error:=MTApi.DeleteOrder(HSocket,StrToInt(sgrOpenPositions.cells[0,sgrOpenPositions.Selection.Top]));
      if error <> RET_OK then ShowMessage('    .  : '+MTApi.GetErrorDescription(error))
      else ShowMessage(' ');
    end;

  disconnect(HSocket);
end;

procedure TfrmMain.btnCloseByClick(Sender: TObject);
var s:string;
    error:integer;
    HSocket: integer;
begin
  HSocket:=connect(server,port);
  error:=MTApi.Login(HSocket,login,password);
  if error<>RET_OK
  then ShowMessage(' .  : '+MTApi.GetErrorDescription(error));

  s:=sgrOpenPositions.cells[2,sgrOpenPositions.Selection.Top];
  if (s='Buy') or (s='Sell') then
    begin
      error:=MTApi.CloseByOrder(HSocket,StrToInt(sgrOpenPositions.cells[0,sgrOpenPositions.Selection.Top]),StrToInt(cbxOrderBy.text));
      if error <> RET_OK then ShowMessage('   .  : '+MTApi.GetErrorDescription(error))
      else ShowMessage(' ');
    end;

  disconnect(HSocket);
end;

procedure TfrmMain.btnModifyOrderClick(Sender: TObject);
var s:string;
begin
   frmModifyOrder.edtPrice.text:=sgrOpenPositions.cells[5,sgrOpenPositions.Selection.Top];
   frmModifyOrder.edtSL.text:=sgrOpenPositions.cells[6,sgrOpenPositions.Selection.Top];
   frmModifyOrder.edtTP.text:=sgrOpenPositions.cells[7,sgrOpenPositions.Selection.Top];
   s:=sgrOpenPositions.cells[2,sgrOpenPositions.Selection.Top];
   if (s='Buy') or (s='Sell') then frmModifyOrder.edtPrice.Enabled:=false else frmModifyOrder.edtPrice.Enabled:=true;
   frmModifyOrder.showModal;
end;

procedure TfrmMain.sgrOpenPositionsSelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
var i:integer;
begin
   cbxOrderBy.Clear;
   for i:=0 to sgrOpenPositions.RowCount-1 do
     begin
       Application.ProcessMessages;
       if Arow<>i then
         begin
           if sgrOpenPositions.Cells[4,i]=sgrOpenPositions.Cells[4,ARow]
             then cbxOrderBy.Items.Add(sgrOpenPositions.Cells[0,i]);
         end;
     end;
   if cbxOrderBy.Items.Count=0 then btnCloseBy.Enabled:=false else btnCloseBy.Enabled:=true;
   cbxOrderBy.ItemIndex:=0;
end;

procedure TfrmMain.btnCloseOrderClick(Sender: TObject);
var i:integer;
begin
   if (sgrOpenPositions.Cells[2,sgrOpenPositions.Selection.Top]='Buy') or (sgrOpenPositions.Cells[2,sgrOpenPositions.Selection.Top]='Sell')
   then
     begin
       for i:=1 to sgrMarketWatch.RowCount-1 do
         begin
           Application.ProcessMessages;
           if sgrMarketWatch.Cells[0,i]=sgrOpenPositions.Cells[4,sgrOpenPositions.Selection.Top]
           then
             begin
               ClosePosition.exemode:=Symbols_exemode[i-1];
               break;
             end;
         end;
       if sgrOpenPositions.Cells[2,sgrOpenPositions.Selection.Top]='Buy' then ClosePosition.isBuyPosition:=true else ClosePosition.isBuyPosition:=false;
       ClosePosition.symbol:=sgrOpenPositions.Cells[4,sgrOpenPositions.Selection.Top];
       ClosePosition.lots:=StrToFloat(sgrOpenPositions.Cells[3,sgrOpenPositions.Selection.Top]);
       ClosePosition.order:=StrToInt(sgrOpenPositions.Cells[0,sgrOpenPositions.Selection.Top]);
       donShowLiveQuotes2:=false;
       frmClosePosition.lblBidAsk.Caption:='Please Request';
       frmClosePosition.showModal;
     end;
end;

end.
